#ifndef	_itmtouch_H_
#define _itmtouch_H_

#define ITM_FULL_PACKET_SIZE     5

typedef struct _ItmTouchPrivateRec
{
	int min_x;				/* Minimum x reported by calibration        */
	int max_x;				/* Maximum x                    */
	int min_y;			        /* Minimum y reported by calibration        */
	int max_y;				/* Maximum y                    */
	int button_number;                      /* Number of emulated buttons */  
        Bool swap_axis;                         /* Touhscreen (and/or) scrren (is/are) rotated */
        int screen_num;				/* Screen associated with the device        */
	int screen_width;			/* Width of the associated X screen     */
	int screen_height;			/* Height of the associated X screen     */
	
        XISBuffer *buffer;                      /* Serial data in buffer */
	unsigned char packet[ITM_FULL_PACKET_SIZE]; /* Valid packet being/just read */
        unsigned char last_packet[ITM_FULL_PACKET_SIZE]; /* Used when receiving a partial/diff packet */
        unsigned char partial_packet[ITM_FULL_PACKET_SIZE]; /* Packet being read */
        unsigned int partial_packet_i;          /* Index into a partial packet */
        Bool button_down;			/* Is the "button" currently down */
        int last_x;                             /* Last x coordinate (used when we receive a lift_off because it didn't contains coordinates) */
        int last_y;                             /* Last y coordinate */
        Bool synchronized;                      /* Are we synchronized, so that we can get packets */
        Bool reading_a_packet;                  /* Are we half synchronized ( if so, we need to read the first complete packet to be synchronized ) */ 
}
ItmTouchPrivateRec, *ItmTouchPrivatePtr;

/*============================================================================
 		Declarations
 ============================================================================*/

/*int DumpOpts (XF86OptionPtr opts);*/
static Bool DeviceControl (DeviceIntPtr dev, int mode);
static Bool DeviceOn (DeviceIntPtr dev);
static Bool DeviceOff (DeviceIntPtr dev);
static Bool DeviceInit (DeviceIntPtr dev);
static void ReadInput (LocalDevicePtr local);
static int  ControlProc (LocalDevicePtr local, xDeviceCtl * control);
static void CloseProc (LocalDevicePtr local);
static int  SwitchMode (ClientPtr client, DeviceIntPtr dev, int mode);
static Bool ConvertProc (LocalDevicePtr local, int first, int num, int v0, int v1, int v2, int v3, int v4, int v5, int *x, int *y);

static Bool xf86ItmTouchSendCommand (unsigned char *type, ItmTouchPrivatePtr priv);
static Bool QueryHardware (LocalDevicePtr local);
static Bool xf86ItmTouchSendPacket (unsigned char *type, int len, ItmTouchPrivatePtr priv);
static int  xf86ItmTouchWaitReply (unsigned char *type, ItmTouchPrivatePtr priv);
static Bool ItmTouchGetPacket (ItmTouchPrivatePtr priv);
static void xf86ItmTouchPrintIdent (unsigned char *packet);
static Bool xf86ItmTouchPrintHwStatus (unsigned char *packet);
static InputInfoPtr ItmTouchPreInit(InputDriverPtr drv, IDevPtr dev, int flags);

/* 
 *    DO NOT PUT ANYTHING AFTER THIS ENDIF
 */
#endif
